<template>
    <div>
        <div class="content">
            <div class="container-fluid">
                <!--~~~~~~~ TABLE ONE ~~~~~~~~~-->
                <div
                    class="_1adminOverveiw_table_recent _box_shadow _border_radious _mar_b30 _p20"
                >
                    <p class="_title0">
                        Role Manangement
                        <Button @click="addModal = true">
                            <Icon type="md-add" /> Add a new Role
                        </Button>
                    </p>

                    <div class="_overflow _table_div">
                        <table class="_table">
                            <!-- TABLE TITLE -->
                            <tr>
                                <th>ID</th>
                                <th>Role Type</th>
                                <th>Created at</th>
                                <th>Action</th>
                            </tr>
                            <!-- TABLE TITLE -->
                            <!-- ITEMS -->
                            <tr v-for="(role, i) in roles" :key="i">
                                <td>{{ role.id }}</td>
                                <td class="_table_name">{{ role.roleName }}</td>
                                <td>{{ role.created_at }}</td>
                                <td>
                                    <Button
                                        type="info"
                                        size="small"
                                        @click="showEditModal(role, i)"
                                        >Edit</Button
                                    >
                                    <Button
                                        type="error"
                                        size="small"
                                        @click="showDeleteModal(role, i)"
                                        >Delete</Button
                                    >
                                </td>
                            </tr>
                            <!-- ITEMS -->
                        </table>
                    </div>
                </div>

                <!-- tag add modal -->
                <Modal
                    v-model="addModal"
                    title="Common Modal dialog box title"
                    :mask-closable="false"
                    :closable="false"
                >
                    <Input v-model="data.roleName" placeholder="Role name" />
                    <div slot="footer">
                        <Button type="default" @click="addModal = false"
                            >Close</Button
                        >
                        <Button
                            type="primary"
                            @click="add()"
                            :disabled="isAdding"
                            :loading="isAdding"
                            >{{ isAdding ? "Adding" : "Add Role" }}</Button
                        >
                    </div>
                </Modal>

                <!-- tag edit modal -->
                <Modal
                    v-model="editModal"
                    title="Common Modal dialog box title"
                    :mask-closable="false"
                    :closable="false"
                >
                    <Input
                        v-model="editData.roleName"
                        placeholder="Edit Role Name"
                    />
                    <div slot="footer">
                        <Button type="default" @click="editModal = false"
                            >Close</Button
                        >
                        <Button
                            type="primary"
                            @click="edit()"
                            :disabled="isAdding"
                            :loading="isAdding"
                            >{{ isAdding ? "Editing..." : "Edit Role" }}</Button
                        >
                    </div>
                </Modal>

                <!-- tag delete modal -->
                <!-- <Modal v-model="delete6Modal" width="360">
                    <p slot="header" style="color:#f60;text-align:center">
                        <Icon type="ios-information-circle"></Icon>
                        <span>Delete confirmation</span>
                    </p>
                    <div style="text-align:center">
                        <p>Are you sure delete Tag?</p>
                    </div>
                    <div slot="footer">
                        <Button
                            type="error"
                            size="large"
                            long
                            :loading="isDeleting"
                            :disabled="isDeleting"
                            @click="deleteTag()"
                            >Delete</Button
                        >
                    </div>
                </Modal> -->
                <delete-modal></delete-modal>
            </div>
        </div>
    </div>
</template>

<script>
import DeleteModal from "../components/deleteModal";
import { mapGetters } from "vuex";
export default {
    components: {
        DeleteModal
    },
    data() {
        return {
            data: {
                roleName: ""
            },
            addModal: false,
            isAdding: false,
            editModal: false,
            roles: [],
            editData: {
                roleName: ""
            },
            index: -1,
            isDeleting: false,
            deleteModal: false,
            deleteItem: {},
            deleteIndex: -1
        };
    },

    methods: {
        async add() {
            if (this.data.roleName.trim() == "")
                return this.e("Role name is required");
            const res = await this.callApi(
                "post",
                "app/create_role",
                this.data
            );
            if (res.status === 201) {
                this.s("Role has been added successfully");
                this.addModal = false;
                this.roles.unshift(res.data);
                this.data.roleName = "";
            } else {
                if (res.status === 422) {
                    if (res.data.errors.roleName) {
                        this.i(res.data.errors.roleName[0]);
                    }
                } else {
                    this.swr();
                }
            }
        },
        async edit() {
            if (this.editData.roleName.trim() == "")
                return this.e("Role name is required");
            const res = await this.callApi(
                "post",
                "app/edit_role",
                this.editData
            );
            if (res.status === 200) {
                // this.tags[this.index].tagName=this.editData.tagName;
                this.s("Role has been added successfully");
                this.editModal = false;
            } else {
                if (res.status === 422) {
                    if (res.data.errors.roleName) {
                        this.i(res.data.errors.tagName[0]);
                    }
                } else {
                    this.swr();
                }
            }
        },
        showEditModal(role, i) {
            this.editData = role;
            this.editModal = true;
            this.index = i;
        },
        showDeleteModal(tag, i) {
            // this.deleteItem = tag;
            // this.deleteIndex = i;
            // this.deleteModal = true;
            const deleteModalObj = {
                showDeleteModal: true,
                deleteUrl: "app/delete_tag",
                data: tag,
                deleteIndex: i,
                isDeleted: false
            };
            // console.log('delete Obj Tag')
            this.$store.commit("setDeleteModalObj", deleteModalObj);
        }
    },
    async created() {
        const res = await this.callApi("get", "app/get_roles");
        if (res.status === 200) {
            console.log(res);
            this.roles = res.data;
        } else {
            this.swr();
        }
    },
    computed: {
        ...mapGetters(["getDeleteModalObj"])
    },
    watch: {
        //update Obj DeleteModalObj thì hàm getter mới được gọi lại,
        //mặc khác nếu update 1 property của DeleteModalObj thì getter sẽ không được gọi
        getDeleteModalObj(obj) {
            if (obj.isDeleted) {
                this.tags.splice(obj.deleteIndex, 1);
            }
        }
    }
};
</script>
